#
/*
 *			P A R S E . C
 */

#include "queue.h"


parse (str, fieldpp)
register char	*str;
register char	***fieldpp;
{
	register char **fp;
	static char *fields[MAXFIELDS];
	int	fcnt = 0;

	fp = fields;	
	while (*str) {
		while (*str == ' ' || *str == '\t')
			str++;
		if (*str == '#' || *str == '\n')
			/* Comment or EOL, ignore rest of line */
			break;
		*fp = str;
		if (++fcnt >= MAXFIELDS) {
			return (-1);
		}
		if( *str == '"' ) {
			*fp = ++str;
			while( *str != '"' && *str != '\n' )
				str++;
			*str++ = 0;

			/* Allow whitespace and a comma after quote */
			while (*str == ' ' || *str == '\t')
				str++;
			if( *str == ',' )
				str++;
		} else {
			while (*str && *str != ' ' && *str != '\t'
			       && *str != ',' && *str != '\n')
				str++;
			if( *str )
				*str++ = 0;
		}
		fp++;
	}
	*fp = 0;
	*fieldpp = fields;
	return (fcnt);
}
